/*


Make a show interface script
Add ctlchoice for object, bones, lights, cameras
Add option to exclude locked item

Hide Nulls
Hide Bones
Hide Lights
Hide Cameras
But will remember which were hidden!? or exclude locked items?
*/
@version 2.7
@warnings
@script master
@name "ef Item Visibility Toggle"
@define NAME "ef Item Visibility Toggle"
@define SERVERNAME "ef_ItemVisibilityToggle"
@define SERVERTYPE "MasterHandler"
@define VERSION 1.45



vis_hidden;
hidden_icon = @ ".........",
				".........",
				".........",
				".........",
				".........",
				".........",
				".........",
				".........",
				"........."
			@;	

			
			
vis_boundingbox;
boundingbox_icon = @ 	"ooooooooo",
						"o.......o",
						"o.......o",
						"o.......o",
						"o.......o",
						"o.......o",
						"o.......o",
						"o.......o",
						"ooooooooo"
					@;			
			
vis_vertices;
vertices_icon = @ 	"o...o...o",
					".........",
					"..o...o..",
					".........",
					"o...o...o",
					".........",
					"..o...o..",
					".........",
					"o...o...o"
				@;			
			
vis_wireframe;
wireframe_icon = @ 	"ooooooooo",
					"oo..o..oo",
					"o.o.o.o.o",
					"o..ooo..o",
					"ooooooooo",
					"o..ooo..o",
					"o.o.o.o.o",
					"oo..o..oo",
					"ooooooooo"
				@;			
			
vis_frontface;
frontface_icon = @ 	"ooooooooo",
					"o...o...o",
					"o...o...o",
					"o...o...o",
					"ooooooooo",
					"o...o...o",
					"o...o...o",
					"o...o...o",
					"ooooooooo"
				@;
			
vis_shadedsolid;
shadedsolid_icon = @ 	"ooooooooo",
						"ooooooooo",
						"ooooooooo",
						"ooooooooo",
						"ooooooooo",
						"ooooooooo",
						"ooooooooo",
						"ooooooooo",
						"ooooooooo"
					@;
						
vis_texturedsolid;
texturedsolid_icon = @ 	"ooooooooo",
						"ooooooooo",
						"oo.....oo",
						"oooo.oooo",
						"oooo.oooo",
						"oooo.oooo",
						"oooo.oooo",
						"ooooooooo",
						"ooooooooo"
					@;
						
vis_texturedwireframe;
texturedwireframe_icon = @ 	"ooooooooo",
							"ooooooooo",
							"....o.o.o",
							"o.o.o.o.o",
							"o.o.o.o.o",
							"o.o.o.o.o",
							"o.o.o.o.o",
							"o.o.....o",
							"ooooooooo"
						@;

								  //lscript mesh : camera/light : bones
@define LWOVIS_HIDDEN			0 //2 : 2 : 2
@define LWOVIS_VISIBLE			1 //- : 1 : 3
@define LWOVIS_BOUNDINGBOX		1 //3
@define LWOVIS_VERTICES			2 //4
@define LWOVIS_WIREFRAME		3 //5
@define LWOVIS_FFWIREFRAME		4 //6
@define LWOVIS_SHADED			5 //7
@define LWOVIS_TEXTURED			6 //8
@define LWOVIS_TEXTURED_WIRE	7 //1!!

@define ITEMTYPE_OBJECT 1 << 0
@define ITEMTYPE_BONE	1 << 1
@define ITEMTYPE_LIGHT	1 << 2
@define ITEMTYPE_CAMERA	1 << 3

@define SELMODE_ITEM 1
@define SELMODE_HIERARCHY 2



o1;o2;o3;o4;o5;
selectionMode; defaultVisibility; defaultInvisibility; toggleActiveState; saveToScene; 
previous_visibility; 	//lwovis
previous_active_state; 	//not implemented
match;


@define LOG 1
logfilename = "c:/ef_itemvisibility_toggle.log";

environment {
	x = runningUnder();
	res = "unknown";
	switch(x) {
		case 1: res = "Layout"; break;
		case 2: res = "Modeler"; break;
		case 3: res = "Screamernet"; break;
	}
	return res;
}
TimeStamp {
	(hour,min,s,t) = time();
	(d,m,y,w,j,sm,sw) = date();
	return (""+y+"-"+m+"-"+d+" "+hour+":"+min);
}

StartLog {
	text = "Running "+SERVERNAME+" v"+VERSION+" on LW v"+hostVersion()+"("+hostBuild()+") under "+(runningUnder()==1?"Layout":runningUnder()==2?"Modeler":runningUnder()==3?"Scremernet":"Unknown")+"("+platform()+").\n";
	AppendToLog(text);
}
AppendToLog: text {
	timestamp = TimeStamp();
	file = File(logfilename,"a");
	file.write(timestamp+" "+text);
	file.close();
}





create
{
	return if(runningUnder() == SCREAMERNET);
	
@if LOG
	StartLog();
	AppendToLog("Instance created.\n");
@end

	setdesc(NAME);

	vis_hidden = Icon(hidden_icon);
	vis_boundingbox = Icon(boundingbox_icon);
	vis_vertices = Icon(vertices_icon);
	vis_wireframe = Icon(wireframe_icon);
	vis_frontface = Icon(frontface_icon);
	vis_shadedsolid = Icon(shadedsolid_icon);
	vis_texturedsolid = Icon(texturedsolid_icon);
	vis_texturedwireframe = Icon(texturedwireframe_icon);
    
	match = regexp("^Generic_"+SERVERNAME);
	previous_visibility["0"] = nil; //init assoc array
	//previous_active_state["0"] = nil;
	
	loadSettings();
}

destroy
{
	return if(runningUnder() == SCREAMERNET);
	
@if LOG
	AppendToLog("Instance destroyed.\n");
@end
    // take care of final clean-up activities here
}

flags
{
	return if(runningUnder() == SCREAMERNET);
    return(SCENE);
}


process: event, command
{
	return if(runningUnder() == SCREAMERNET);

	if( event == COMMAND && command == match ) {
		(nil,nil,nil,funcName,nil) = parse("_ ", command);

		select
	        when funcName == "HideSelected" then do
				hideSelected();
				end
			when funcName == "ShowSelected" then do
				showSelected();
				end
			when funcName == "HideUnselected" then do
				hideUnselected();
				end
			when funcName == "ShowUnselected" then do
				showUnselected();
				end
			when funcName == "HideAll" then do
				hideAll();
				end
			when funcName == "ShowAll" then do
				showAll();
				end
			when funcName == "InvertSelected" then do
				invertSelected();
				end
			when funcName == "InvertUnselected" then do
				invertUnselected();
				end		
			when funcName == "InvertAll" then do
				invertAll();
				end					
	     end
		 
		 Refresh();
	}
}

load: what,io
{
	return if(runningUnder() == SCREAMERNET);
	
	if(what == SCENEMODE && saveToScene == 1)
    {
		line = io.read();
		while( line != nil )
		{
			line = parse(" ", line);
			select
				when line[1] == "Version" then do
					//do nothing
					end
				when line[1] == "ItemVisibility" then do
					previous_visibility[line[2]] = integer(line[3]);
					end
				/* ///Deprecated
				when line[1] == "ItemState" then do
				   previous_active_state[line[2]] = integer(line[3]);
				   end
				*/
			end
			line = io.read();
		}
	}
}

save: what,io
{
	return if(runningUnder() == SCREAMERNET);

@if LOG
	AppendToLog("Saving to Scene Started. ("+saveToScene+")\n");
@end

@if LOG
	AppendToLog("Weeding.\n");
@end
	
	Weed(previous_visibility);

	if(what == SCENEMODE && saveToScene == 1)
    {		
@if LOG
	AppendToLog("Versioning.\n");
@end
		
		io.writeln("Version "+VERSION);	
						
		keys = previous_visibility.keys();
		
@if LOG
	AppendToLog("Writing entries ("+keys.count()+").\n");
@end
		
		if( keys != nil ) {
			for( i=1; i<=keys.count(); i++ ) {
				if( previous_visibility[keys[i]] != nil ) {
					key = keys[i];
					vis = previous_visibility[keys[i]];

					if(key.isStr() && vis.isInt()) {
						entry = "ItemVisibility "+key+" "+vis;
@if LOG
	AppendToLog("Writing entry ("+i+") ("+entry+").\n");
@end
						io.writeln( entry );
					}
				}
			}
		}
		/* ///Deprecated
		keys = previous_active_state.keys();
		if( keys != nil ) {
			for( i=1; i<=keys.count(); i++ ) {
				if( previous_active_state[keys[i]] != nil ) {
					io.writeln( "ItemVisibility "+keys[i]+" "+previous_active_state[keys[i]] );
				}
			}
		}
		*/
	}
	
@if LOG
AppendToLog("Saving to Scene ended.\n");
@end
}

loadSettings {
	filename = SCRIPTID; //gets full path of script
	filename ~= r~ls.?$~cfg~; //exchanges extension .ls or .lsc for .dat
	file = File(filename, "r");
	if(file != nil && file.isOpen()) {
		while(!file.eof()) {
		line = parse(" ", file.read());
			select
				when line[1] == "Version" then do
					//do nothing
					end
				when line[1] == "SelectionMode" then do
					setSelectionMode( integer( line[2] ) );
					end
				when line[1] == "DefaultVisibility" then do
					defaultVisibility = integer( line[2] );
					end
				when line[1] == "DefaultInvisibility" then do
					defaultInvisibility = integer( line[2] );
					end
            	when line[1] == "ToggleActiveState" then do
					setToggleActiveState( integer(line[2]) ); 
					end	
				when line[1] == "SaveToScene" then do
					setSaveToScene( integer(line[2]) ); 
					end	
			end
		}
		file.close();
	}
	
	if(selectionMode==nil) selectionMode = SELMODE_HIERARCHY;
	if(defaultVisibility==nil) defaultVisibility = LWOVIS_TEXTURED;
	if(defaultInvisibility==nil) defaultInvisibility = LWOVIS_HIDDEN;
	if(toggleActiveState==nil) toggleActiveState = 0;
	if(saveToScene==nil) saveToScene = 0;
}

saveSettings {
	filename = SCRIPTID; //gets full path of script
	filename ~= r~ls.?$~cfg~; //exchanges extension .ls or .lsc for .dat
	file = File(filename, "w");
	if(file != nil && file.isOpen()) {
		file.writeln("Version "+VERSION);
		file.writeln("SelectionMode "+selectionMode);
		file.writeln("DefaultInvisibility "+defaultInvisibility);
		file.writeln("DefaultVisibility "+defaultVisibility);
        file.writeln("ToggleActiveState "+toggleActiveState);
		file.writeln("SaveToScene "+saveToScene);
		file.close();
	}
}

options
{
	if( reqisopen() )
    reqend();
	
	reqbegin(""+NAME+" v"+VERSION);
	
	mode_choices = 	@	"Selected Items Only",
						"Selected and Children"
					@;
					
	item_types = 	@	"Objects",
						"Bones",
						"Lights",
						"Cameras"
					@;
					
	invis_choices = @	""+vis_hidden+" Hidden",
						""+vis_boundingbox+" Bounding Box",
						""+vis_vertices+" Vertices",
						""+vis_wireframe+" Wireframe",
						""+vis_frontface+" Front Face Wireframe"
					@;
					
	vis_choices = 	@	""+vis_shadedsolid+" Shaded Solid",
						""+vis_texturedsolid+" Texture Shaded Solid",
						""+vis_texturedwireframe+" Texture Shaded Solid Wireframe"
					@;
		
	o1 = ctlchoice("Affect", selectionMode, mode_choices);
	
	o5 = ctlpopup("Hide as", defaultInvisibility + 1, invis_choices);
	o2 = ctlpopup("Default Visibility", defaultVisibility + 1 - 5, vis_choices); //+1 to match sdk, -5 to match vis_choices
	//o2.visible(0); //hidden because it's likely not used/noticed by anyone anyhow, and just confusing.
	
	ctlsep();
	
	x = 40; y = 0;
	hs = ctlbutton("Hide Selected", 150, "hideSelected");
	hu = ctlbutton("Hide Unselected", 150, "hideUnselected");
	ha = ctlbutton("Hide All", 150, "hideAll");
	ctlsep();
	ss = ctlbutton("Show Selected", 150, "showSelected");	
	su = ctlbutton("Show Unselected", 150, "showUnselected");
	sa = ctlbutton("Show All", 150, "showAll");
	ctlsep();
	ss = ctlbutton("Invert Selected", 150, "invertSelected");	
	su = ctlbutton("Invert Unselected", 150, "invertUnselected");
	sa = ctlbutton("Invert All", 150, "invertAll");
	
	ctlsep();
	
    o4 = ctlcheckbox("Toggle Active State for Object", toggleActiveState);
    
    ctlsep();
    
	o3 = ctlcheckbox("Save Item Visibility to Scene", saveToScene);
	
	ctltext("","");
	
	ctlrefresh(o1, "setSelectionMode");
	ctlrefresh(o2, "setDefaultVisibility");
	ctlrefresh(o5, "setDefaultInvisibility");
    ctlrefresh(o4, "setToggleActiveState");
	ctlrefresh(o3, "setSaveToScene");
	
    reqopen();
}

// reqmousetrack: md {
    // //implement hints.
// }

setSelectionMode: value
{
	selectionMode = value;
	
	saveSettings();

    if( reqisopen() )
    {
        setvalue( o1, selectionMode );
    }
}

setDefaultVisibility: value
{
	defaultVisibility = value - 1 + 5;
	
	saveSettings();

    if( reqisopen() )
    {
        setvalue( o2, (defaultVisibility + 1 - 5) );
    }
}

setDefaultInvisibility: value
{
	defaultInvisibility = value - 1;
	
	saveSettings();

    if( reqisopen() )
    {
        setvalue( o5, (defaultInvisibility + 1) );
    }
}

setToggleActiveState: value {
	toggleActiveState = value;

	saveSettings();
	
    if( reqisopen() )
    {
        setvalue( o4, (toggleActiveState) );
    }
}

setSaveToScene: value
{
	saveToScene = value;

	saveSettings();
	
    if( reqisopen() )
    {
        setvalue( o3, (saveToScene) );
    }
}


hideSelected {
	selected = Scene().getSelect();
	
	if(selectionMode == SELMODE_HIERARCHY)
		items = addChildren(selected);
	else
		items = selected;
	
	hideItems(items);
	Select(selected);
}

showSelected {
	selected = Scene().getSelect();
	
	if(selectionMode == SELMODE_HIERARCHY)
		items = addChildren(selected);
	else
		items = selected;
	
	showItems(items);
	Select(selected);
}

hideUnselected{
	all = getAllItems();
	selected = Scene().getSelect();
	
	if(selectionMode == SELMODE_HIERARCHY)
		items = addChildren(selected);
	else
		items = selected;
		
	items = setSubtract( all, items );
	
	hideItems(items);
	Select(selected);
}

showUnselected{
	all = getAllItems();
	selected = Scene().getSelect();
	
	if(selectionMode == SELMODE_HIERARCHY)
		items = addChildren(selected);
	else
		items = selected;
		
	items = setSubtract( all, items );
	
	showItems(items);
	Select(selected);
}

hideAll{
	selected = Scene().getSelect();
	items = getAllItems();
	hideItems(items);
	
	Select(selected);
}

showAll{
	selected = Scene().getSelect();
	items = getAllItems();
	showItems(items);
	
	Select(selected);
}



invertSelected{
	selected = Scene().getSelect();
	
	if(selectionMode == SELMODE_HIERARCHY)
		items = addChildren(selected);
	else
		items = selected;
		
	invertItems(items);
	
	Select(selected);
}

invertUnselected{
	all = getAllItems();
	selected = Scene().getSelect();
	
	if(selectionMode == SELMODE_HIERARCHY)
		items = addChildren(selected);
	else
		items = selected;
	
	items = setSubtract( all, items );
	invertItems(items);
	
	Select(selected);
}

invertAll{
	selected = Scene().getSelect();
	items = getAllItems();
	invertItems(items);
	
	Select(selected);
}



getVisibility: item {
	vis = item.visibility;
	lwovis = LWOVIS_TEXTURED;

	if( item.genus == MESH ) {
		switch(vis) {
			//in lscript 1 is texture shaded wireframe (7 in sdk), and is otherwise offset by 2.
			case 1: lwovis = LWOVIS_TEXTURED_WIRE; break;
			case 2: lwovis = LWOVIS_HIDDEN; break;
			case 3: lwovis = LWOVIS_BOUNDINGBOX; break;
			case 4: lwovis = LWOVIS_VERTICES; break;
			case 5: lwovis = LWOVIS_WIREFRAME; break;
			case 6: lwovis = LWOVIS_FFWIREFRAME; break;
			case 7: lwovis = LWOVIS_SHADED; break;
			case 8: lwovis = LWOVIS_TEXTURED; break;
		}
	}
	else if(item.genus==LIGHT || item.genus==CAMERA) {
		switch(vis) {
			//for non-meshes, hidden is 2 inlscript, visible is 1.
			case 2: lwovis = LWOVIS_HIDDEN; break;
			case 1: lwovis = LWOVIS_VISIBLE; break;
			default: LWOVIS_VISIBLE; break;
		}
	}
	else if(item.genus==BONE) {
		switch(vis) {
			//for non-meshes, hidden is 2 inlscript, visible is 1.
			case 2: lwovis = LWOVIS_HIDDEN; break;
			case 3: lwovis = LWOVIS_VISIBLE; break;
			default: LWOVIS_VISIBLE; break;
		}
	}
	return lwovis;
}

setVisibility: item, visibility {
	SelectItem( item.id );

	CommandInput("ItemVisibility "+visibility);

    if(item.genus==MESH && toggleActiveState) {
        if(visibility<=defaultInvisibility) {
            CommandInput("ItemActive "+0);
		}
        else {
            CommandInput("ItemActive "+1);
		}
    }
}

isVisible: item {
	result = false;
	lwovis = getVisibility(item);
	if( item.genus == MESH ) {
		if(lwovis>=LWOVIS_VISIBLE) result = true; //LWOVIS_VISIBLE is same as LWOVIS_BOUNDINGBOX
	}
	else if(item.genus==LIGHT || item.genus==CAMERA || item.genus==BONE) {
		if(lwovis==LWOVIS_VISIBLE) result = true;
	}
	return result;
}

isVisibleState: item, vis {

}

hideItems: items {	
	for( i=1; i<=items.count(); i++ ) {
		item = items[i];
		if(!isVisible(item)) continue;
		if(item.genus == MESH) {
			id = item.id.asStr();
			vis = getVisibility(item);
			previous_visibility[id] = getVisibility(item);
			lwovis = defaultInvisibility;
		}		
		else if(item.genus==LIGHT || item.genus==CAMERA || item.genus==BONE) {
			lwovis = LWOVIS_HIDDEN;
		}
        //this code is outside the if-case so you can rehide after changing toggleItemActive state. Yet the internal data is untouched.
        
		setVisibility( item, lwovis );
	}
}

showItems: items {
	for( i=1; i<=items.count(); i++ ) {
		item = items[i];
		if(isVisible(item)) continue;
		if(item.genus == MESH) {
			id = item.id.asStr();
			lwovis = previous_visibility[id];
			//previous_visibility[id] = nil; //necessary?
			lwovis = lwovis==nil || lwovis<=defaultInvisibility ? defaultVisibility : lwovis;
		}
		else if(item.genus==LIGHT || item.genus==CAMERA || item.genus==BONE) {
			lwovis = LWOVIS_VISIBLE;
		}
        //this code is outside the if-case so you can rehide after changing toggleItemActive state. Yet the internal data is untouched.
		setVisibility( item, lwovis );
	}
}

invertItems: items {
	for( i=1; i<=items.count(); i++ ) {
		item = items[i];
		if(isVisible(item)) {
			hide[hide.count()+1] = item;
		}
		else {
			show[show.count()+1] = item;
		}
	}
	hideItems(hide);
	showItems(show);
}




/////////////////////////

//removes entries for items no longer in existance
Weed: ass_array {
	keys = ass_array.keys();
	if( keys != nil ) {
		for( i=1; i<=keys.count(); i++ ) {
			str = keys[i];
			id = str.asInt();
			item = Item(id);
			if(item==nil || !item.isValid()) {
				ass_array[keys[i]] = nil;
			}
		}
	}
	ass_array.pack();
	ass_array.trunc();
}


/*Retrieves object agent of any item type
param id    - the layout item id.
return      - the object agent of the matching item or nil if no match found.
depend      - Bone(id).
*/
Item: id {
	oa      = nil;
	
	if(id>0) { //crude but enough
		genus   = integer( id / integer( 0x10000000 ) );
		
		switch( genus ) {
			case MESH: //1
				oa = Mesh( id );
				break;
			
			case LIGHT: //2
				oa = Light( id );
				break;
				
			case CAMERA: //3
				oa = Camera( id );
				break;

			case BONE: //4
				oa = Bone(id);
				break;
		}
	}
    
    return oa;
}



/*Retrieves bone object agent
param id    - the layout bone id.
return      - the bone object agent of the matching bone or nil if no match was found.
*/
Bone: id {
    mesh = Mesh();

    while( mesh ) {
    
        bone = mesh.bone();
        while( bone ) {
            if( bone.id == id )
                return bone;
            else
                bone = bone.next();
        }
        
        mesh.next();
    }
    
    return nil;
}


Select: items
{
    if( !items.size() ) { //argument was single variable
        SelectItem( items.id );
        return;
    }
    
    else { //argument was array
        SelectItem( items[items.size()].id );

        for( i = items.size() - 1; i > 0; i-- )
            AddToSelection( items[i].id );
    }
}



st_items;
addChildren: items {

    st_items = nil;

    if( !items.size() ) { //argument was single variable
        items[1] = items;
    }
    
    foreach(item, items) {
        childRecurser(item);
    }
    
    st_items.sortA();
    st_items.reduce();
    
    return st_items;
}

childRecurser: item
{
    st_items += item;

    if( child = item.firstChild() )
    {
        childRecurser( child );

        while( child = item.nextChild() )
        {
            childRecurser( child );
        }    
    }
}



//Returns all item oa in id order. Objects first, Bones last.
getAllItems {
    items;
    objs;

    first = Mesh();
    for( item = first; item != nil; item = item.next() ) {
        items += item;
        objs += item;
    }
    
    first = Light();
    for( item = first; item != nil; item = item.next() ) {
        items += item;
    }
    
    first = Camera();
    for( item = first; item != nil; item = item.next() ) {
        items += item;
    }
    
    nobjects = objs.count();
    for( i=1; i<=nobjects; i++ ) {
        for( item = objs[i].bone(); item != nil; item = item.next() ) {
            items += item;
        }
    }   

    return items;
}


//////////////////////

setSubtract: a, b {
	acount = a.count();
	bcount = b.count();
	
	for( i=1; i<=acount; i++ ) {
		for( j=1; j<=bcount; j++ ) {
			if( a[i].id == b[j].id ) {
				a[i] = nil;
				b[j] = b[bcount]; //at first match, remove from search, assumes no duplicates
				bcount--;
				j--;
				break;
			}
		}
	}
	a.pack();
	a.trunc();
	
	return a;
}


